import { r as registerInstance, e as createEvent, h, g as getElement } from './index-06929dd0.js';

const accordionCss = ".accordion_header{display:grid;grid-auto-flow:column;gap:24px;-ms-flex-pack:start;justify-content:start;-ms-flex-align:center;align-items:center;padding:24px;padding-right:56px;position:relative;color:var(--color-content-default, #454545);cursor:pointer}.accordion_header::before{content:\"\";position:absolute;inset:0;z-index:0}.accordion_header *{position:relative;z-index:1}.accordion_header:hover::before{background-color:var(--color-content-default, #454545);opacity:0.08}.accordion_header .accButton{position:absolute;right:24px;top:calc(50% - 16px);border-radius:8px;contain:inherit;-webkit-transition:height 0.5s, all 0.3s;-moz-transition:height 0.5s, all 0.3s;transition:height 0.5s, all 0.3s;z-index:1}.accordion_header .accButton__isopen{-webkit-transform:rotate(180deg);transform:rotate(180deg)}.accordion_header .accButton::before{content:\"\";position:absolute;inset:-4px;border:2px solid transparent;border-radius:4px}.accordion_header .accButton:focus-visible{outline:none}.accordion_header .accButton:focus-visible::before{border-color:var(--color-focus, #c226fb)}.accordion_header .accButton:hover{background-color:var(--color-surface-1, #f6f6f6)}.accordion_header .accButton:active{background-color:var(--color-surface-1, #f6f6f6)}.accordion_body{height:0;overflow:hidden;border-bottom:1px solid var(--color-border-1, #c9c9c9);-webkit-transition:height 0.5s;-moz-transition:height 0.5s;transition:height 0.5s}.accordion_body::-webkit-scrollbar{width:16px;background-color:transparent}.accordion_body::-webkit-scrollbar-thumb{border-radius:10px;border:4px solid transparent;border-radius:10px;background-clip:content-box;background-color:#b9cbd3}.accordion_body_isOpen{overflow:overlay}.accordion_body .container{padding:8px 24px 48px;position:relative;color:var(--color-content-default, #454545)}";

const AccordionGroup = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.bdsAccordionCloseAll = createEvent(this, "bdsAccordionCloseAll", 7);
    this.bdsAccordionOpenAll = createEvent(this, "bdsAccordionOpenAll", 7);
    this.accordionsElement = null;
    this.collapse = 'single';
  }
  async closeAll(actNumber) {
    this.bdsAccordionCloseAll.emit();
    for (let i = 0; i < this.accordionsElement.length; i++) {
      if (this.collapse != 'multiple') {
        if (actNumber != i)
          this.accordionsElement[i].close();
      }
      else {
        this.accordionsElement[i].close();
      }
    }
  }
  async openAll(actNumber) {
    this.bdsAccordionOpenAll.emit();
    for (let i = 0; i < this.accordionsElement.length; i++) {
      if (this.collapse != 'multiple') {
        if (actNumber != i)
          this.accordionsElement[i].open();
      }
      else {
        this.accordionsElement[i].open();
      }
    }
  }
  componentWillRender() {
    this.accordionsElement = this.element.getElementsByTagName('bds-accordion');
    for (let i = 0; i < this.accordionsElement.length; i++) {
      this.accordionsElement[i].reciveNumber(i);
    }
  }
  render() {
    return (h("div", { class: "accordion_group" }, h("slot", null)));
  }
  get element() { return getElement(this); }
};
AccordionGroup.style = accordionCss;

export { AccordionGroup as bds_accordion_group };
