import { r as registerInstance, e as createEvent, h, f as Host, g as getElement } from './index-06929dd0.js';

const buttonCss = ":host(.block){width:100%;display:-ms-flexbox;display:flex}:host{position:relative}:host:focus-visible{outline:none}.button{border:none;margin:0;padding:0;width:auto;overflow:visible;outline:none;background:transparent;color:inherit;font:inherit;line-height:normal;-webkit-font-smoothing:inherit;-moz-osx-font-smoothing:inherit;-webkit-appearance:none;cursor:pointer;display:-ms-flexbox;display:flex;-ms-flex-direction:row;flex-direction:row;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;height:100%;border-radius:8px;padding-left:16px;padding-right:16px;position:relative;-webkit-box-sizing:border-box;box-sizing:border-box;-webkit-transition:all 0.5s;-moz-transition:all 0.5s;transition:all 0.5s}.button::-moz-focus-inner{border:0;padding:0}.button--block{width:100%}.button bds-loading-spinner{max-height:100%;position:absolute}.button *{pointer-events:none}.button--size-tall{padding-top:14px;padding-bottom:14px;height:40px}.button--size-tall--icon{padding-top:12px;padding-bottom:12px;height:40px}.button--size-standard{padding-top:9px;padding-bottom:9px;height:40px}.button--size-standard bds-loading-spinner{width:32px;height:32px;top:calc(50% - 16px)}.button--size-standard--icon{padding-top:8px;padding-bottom:8px;height:40px}.button--size-short{padding-top:5px;padding-bottom:5px;height:32px}.button--size-short bds-loading-spinner{width:16px;height:16px;top:calc(50% - 8px)}.button--size-short--icon{padding-top:4px;padding-bottom:4px;height:32px}.button--size-icon--left{padding-left:16px}.button--size-icon--right{padding-right:16px}.button__icon{color:inherit;background-color:inherit;height:24px;margin-right:4px}.button__arrow{color:inherit;background-color:inherit;height:24px;margin-left:2px}.button__content{height:20px;display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center;z-index:1}.button::before{content:\"\";position:absolute;top:0;left:0;width:100%;height:100%;background-color:transparent;z-index:0;border-radius:8px}.button:hover::before{background-color:var(--color-hover, rgba(0, 0, 0, 0.08))}.button:active::before{background-color:var(--color-pressed, rgba(0, 0, 0, 0.16))}.button__primary{background:var(--color-surface-primary, #1e6bf1)}.button__primary .typo_buttom,.button__primary .icon_buttom,.button__primary .arrow_buttom{color:var(--color-content-bright, #ffffff)}.button__primary--disabled{opacity:50%;pointer-events:none;color:var(--color-content-bright, #ffffff)}.button__primary--disabled:hover,.button__primary--disabled:active{color:var(--color-content-bright, #ffffff)}.button__secondary{background:transparent}.button__secondary .typo_buttom,.button__secondary .icon_buttom,.button__secondary .arrow_buttom{color:var(--color-content-default, #454545)}.button__secondary--disabled{opacity:50%;pointer-events:none;color:#637798}.button__secondary--disabled:hover,.button__secondary--disabled:active{color:#637798}.button__tertiary{background:transparent;border:1px solid var(--color-border-1, #c9c9c9)}.button__tertiary .typo_buttom,.button__tertiary .icon_buttom,.button__tertiary .arrow_buttom{color:var(--color-content-default, #454545)}.button__tertiary--disabled{opacity:50%;pointer-events:none;color:#637798;border:1px solid #637798}.button__tertiary--disabled:hover,.button__tertiary--disabled:active{color:#637798;border:1px solid #637798}.button__secondary--white{background:transparent}.button__secondary--white .typo_buttom,.button__secondary--white .icon_buttom,.button__secondary--white .arrow_buttom{color:#ffffff}.button__secondary--white:hover{background:rgba(255, 255, 255, 0.3);color:#ffffff}.button__secondary--white:active{background:rgba(255, 255, 255, 0.4);color:#ffffff}.button__secondary--white--disabled{opacity:50%;pointer-events:none;color:#8ca0b3}.button__secondary--white--disabled:hover,.button__secondary--white--disabled:active{color:#8ca0b3}.button__ghost{background:transparent;border:1px solid var(--color-border-1, #c9c9c9)}.button__ghost .typo_buttom,.button__ghost .icon_buttom,.button__ghost .arrow_buttom{color:var(--color-content-default, #454545)}.button__ghost--disabled{opacity:50%;pointer-events:none;color:#637798;border:1px solid #637798}.button__ghost--disabled:hover,.button__ghost--disabled:active{color:#637798;border:1px solid #637798}.button__delete{background:var(--color-delete, #e60f0f)}.button__delete .typo_buttom,.button__delete .icon_buttom,.button__delete .arrow_buttom{color:var(--color-content-bright, #ffffff)}.button__delete--disabled{opacity:50%;pointer-events:none;color:#ba5a5a}.button__delete--disabled:hover,.button__delete--disabled:active{color:#ba5a5a}.button__dashed{background:transparent;border:1px dashed #3f7de8}.button__dashed .typo_buttom,.button__dashed .icon_buttom,.button__dashed .arrow_buttom{color:#3f7de8}.button__dashed:hover{background:transparent;color:#125ad5;border:1px dashed #125ad5}.button__dashed:active{background:transparent;color:#3f7de8;border:1px dashed #3f7de8}.button__dashed--disabled{opacity:50%;pointer-events:none;color:#8ca0b3;border:1px dashed #8ca0b3}.button__dashed--disabled:hover,.button__dashed--disabled:active{color:#8ca0b3;border:1px dashed #8ca0b3}.button__facebook{background:#1877f2}.button__facebook .typo_buttom,.button__facebook .icon_buttom,.button__facebook .arrow_buttom{color:#f8fbfb}.button__facebook:hover{background:#1771e6}.button__facebook:active{background:#3f7de8;color:#f8fbfb}.button__facebook--disabled{opacity:50%;pointer-events:none;color:#8ca0b3}.button__facebook--disabled:hover,.button__facebook--disabled:active{color:#8ca0b3}.button .hide{cursor:not-allowed;opacity:0}.focus:focus-visible{display:-ms-flexbox;display:flex;position:absolute;border:2px solid var(--color-focus, #c226fb);border-radius:4px;width:100%;height:100%;top:-4px;left:-4px;padding-right:4px;padding-bottom:4px;outline:none}.disabled{pointer-events:none}";

const Button = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.bdsClick = createEvent(this, "bdsClick", 7);
    this.handleClick = (ev) => {
      if (!this.disabled) {
        if (ev.key == 'Enter') {
          this.bdsClick.emit(ev);
        }
        if (ev.type == 'click') {
          this.bdsClick.emit(ev);
        }
        const form = this.el.closest('form');
        if (form) {
          ev.preventDefault();
          const fakeButton = document.createElement('button');
          fakeButton.type = this.type;
          fakeButton.style.display = 'none';
          form.appendChild(fakeButton);
          fakeButton.click();
          fakeButton.remove();
        }
      }
    };
    this.block = false;
    this.disabled = false;
    this.size = 'standard';
    this.variant = 'primary';
    this.icon = null;
    this.arrow = false;
    this.type = 'button';
    this.iconTheme = 'outline';
    this.typeIcon = 'icon';
    this.bdsLoading = false;
    this.bdsLoadingVariant = 'primary';
    this.bdsLoadingColor = 'main';
    this.dataTest = null;
  }
  getSizeClass() {
    return this.arrow || !!this.icon ? `button--size-${this.size}--icon` : `button--size-${this.size}`;
  }
  renderIcon() {
    return (this.icon && (h("div", { class: { button__icon: true, hide: this.bdsLoading && true } }, h("bds-icon", { class: { icon_buttom: true }, name: this.icon, theme: this.iconTheme, type: this.typeIcon, color: "inherit" }))));
  }
  renderText() {
    return (h("div", { class: {
        button__content: true,
        [`button__content__${this.variant}`]: true,
        [`button__content__${this.variant}--disabled`]: this.disabled,
        hide: this.bdsLoading && true,
      } }, h("bds-typo", { class: { typo_buttom: true }, variant: "fs-14", lineHeight: "simple", bold: "bold" }, h("slot", null))));
  }
  renderArrow() {
    return (this.arrow && (h("div", { class: { button__arrow: true, hide: this.bdsLoading && true } }, h("bds-icon", { class: { arrow_buttom: true }, name: "arrow-right", color: "inherit" }))));
  }
  renderLoadingSpinner() {
    const loadingColor = this.variant == 'primary' || this.variant == 'delete' ? 'light' : 'main';
    if (this.size === 'short') {
      return h("bds-loading-spinner", { size: "extra-small", color: loadingColor });
    }
    else {
      return h("bds-loading-spinner", { size: "small", color: loadingColor });
    }
  }
  render() {
    const sizeClass = this.getSizeClass();
    return (h(Host, { class: { host: true, block: this.block } }, h("div", { tabindex: "0", onKeyDown: (ev) => this.handleClick(ev), class: "focus" }), h("button", { onClick: (ev) => this.handleClick(ev), disabled: this.disabled, tabindex: "-1", "aria-disabled": this.disabled ? 'true' : 'false', "aria-live": "assertive", type: this.type, class: {
        button: true,
        'button--block': this.block,
        [`button__${this.variant}`]: true,
        [`button__${this.variant}--disabled`]: this.disabled,
        [sizeClass]: true,
        'button--size-icon--left': !!this.icon,
        'button--size-icon--right': this.arrow,
      }, part: "button", "data-test": this.dataTest }, [this.bdsLoading && this.renderLoadingSpinner(), this.renderIcon(), this.renderText(), this.renderArrow()])));
  }
  get el() { return getElement(this); }
};
Button.style = buttonCss;

export { Button as bds_button };
