'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-47da0942.js');

const typoCss = ":host{color:var(--color-content-default, #454545)}.typo{margin:0;font-family:\"Nunito Sans\", \"Carbona\", \"Tahoma\", \"Helvetica\", \"Arial\", sans-serif;font-style:normal;font-weight:normal;margin:0;-webkit-margin-before:0;margin-block-start:0;-webkit-margin-after:0;margin-block-end:0;-webkit-margin-start:0;margin-inline-start:0;-webkit-margin-end:0;margin-inline-end:0;padding:0;border:0}.typo--italic{font-style:italic}.typo--no-wrap{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.typo--paragraph{margin-bottom:16px}.typo__variant--fs-10{font-size:0.625rem;line-height:150%}.typo__variant--fs-12{font-size:0.75rem;line-height:150%}.typo__variant--fs-14{font-size:0.875rem;line-height:150%}.typo__variant--fs-16{font-size:1rem;line-height:150%}.typo__variant--fs-20{font-size:1.25rem;line-height:100%}.typo__variant--fs-24{font-size:1.5rem;line-height:100%}.typo__variant--fs-32{font-size:2rem;line-height:100%}.typo__variant--fs-40{font-size:2.5rem;line-height:100%}.typo__margin--fs-20{margin-bottom:22px}.typo__margin--fs-24{margin-bottom:22px}.typo__margin--fs-32{margin-bottom:22px}.typo__margin--fs-40{margin-bottom:20px}.typo__line-height--none{line-height:0%}.typo__line-height--small{line-height:5%}.typo__line-height--simple{line-height:100%}.typo__line-height--plus{line-height:150%}.typo__line-height--double{line-height:200%}.typo__bold--regular{font-weight:400}.typo__bold--semi-bold{font-weight:600}.typo__bold--bold{font-weight:700}.typo__bold--extra-bold{font-weight:800}";

const Typo = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.variant = 'fs-16';
    this.lineHeight = null;
    this.bold = null;
    this.italic = false;
    this.noWrap = false;
    this.paragraph = false;
    this.margin = true;
    this.tag = 'p';
    this.dataTest = null;
  }
  render() {
    const Element = this.tag;
    return (index.h(Element, { class: {
        typo: true,
        [`typo__variant--${this.variant}`]: true,
        [`typo__margin--${this.variant}`]: this.margin,
        'typo--no-wrap': this.noWrap,
        'typo--paragraph': this.paragraph,
        'typo--italic': this.italic,
        [`typo__line-height--${this.lineHeight}`]: !!this.lineHeight,
        [`typo__bold--${this.bold}`]: !!this.bold,
      }, part: "bds-typo__text", "data-test": this.dataTest }, index.h("slot", null)));
  }
};
Typo.style = typoCss;

exports.bds_typo = Typo;
