import { Event, EventEmitter } from '../../stencil-public-runtime';
export type PaginationOptionsPositionType = 'auto' | 'top' | 'bottom';
export declare class Pagination {
  private el;
  /**
   * State for keep the value selected on select:
   */
  value: number;
  /**
   * State for keep if the select are open or close;
   */
  openSelect: boolean;
  /**
   * State for recive and save the number of pages.
   */
  paginationNumbers: any[];
  intoView?: HTMLElement;
  /**
   * Prop to recive the number of pages.
   */
  pages?: number;
  /**
   * When the component are render this page are set.
   */
  startedPage?: number;
  /**
   * Set the placement of the options menu. Can be 'bottom' or 'top'.
   */
  optionsPosition?: PaginationOptionsPositionType;
  /**
   * Data test is the prop to specifically test the component action object.
   * dtButtonInitial is the data-test to button initial.
   */
  dtButtonInitial?: string;
  /**
   * Data test is the prop to specifically test the component action object.
   * dtButtonPrev is the data-test to button prev.
   */
  dtButtonPrev?: string;
  /**
   * Data test is the prop to specifically test the component action object.
   * dtSelectNumber is the data-test to select number.
   */
  dtSelectNumber?: string;
  /**
   * Data test is the prop to specifically test the component action object.
   * dtButtonNext is the data-test to button next.
   */
  dtButtonNext?: string;
  /**
   * Data test is the prop to specifically test the component action object.
   * dtButtonEnd is the data-test to button end
   */
  dtButtonEnd?: string;
  /**
   * When de value of component change, the event are dispache.
   */
  bdsPaginationChange: EventEmitter;
  componentWillLoad(): void;
  pagesChanged(): void;
  valueChanged(): void;
  countPage(): void;
  previewPage: (event: Event) => void;
  nextPage: (event: Event) => void;
  firstPage: (event: Event) => void;
  lastPage: (event: Event) => void;
  openOptions: () => void;
  onBlur: () => void;
  optionSelected(index: any): void;
  render(): any;
}
